/***************************************************************************
                          main.c  -  experimental frontend for the encrypting
                          decrypting engine.
                             -------------------
    begin                : Thu Nov 16 16:59:50 EST 2000
    copyright            : (C) 2000 by Brian Wagener
    email                : CptanPanic@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <rijndael.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>


int
main (int argc, char *argv[])
{

  FILE *ran = fopen ("/dev/random", "r");
  char file[100];
  FILE *fin;
  FILE *fout;
  int i, j, k, nb = 8, nk = 8;
  char key[32];
  char block[32];
  int ENCRYPT = 99;
  int READY = 0;

  // creates random key.

  if (argc == 1)
    {
      printf ("star: missing options( \"star --help\" for help\n");
      printf ("sample usage: star [options] \n");
      exit (EXIT_FAILURE);
    }
  else
    {
      for (i = 1; i < argc; i++)
	{
	  if (argv[i][0] == '-')
	    {
	      if (argv[i][1] == '-')
		{
		  // This is where we put things like --version and --help
		  switch (argv[i][2])
		    {
		    case 'v':
		      printf ("star version: .1\n");
		      break;
		    case 'h':
		      printf ("star: help\n");
		      printf ("-k <keyfile> : set keyfile\n");
		      printf ("-m <keyfile> : create keyfile\n");
		      printf ("-c : create star file by encrypting\n");
		      printf ("-x : decrypt star file\n");
		      printf ("-f <file> : set in/out file\n");
		      printf ("-b <num> :  force blocksize\n");
		      printf ("-k <num> : force keysize\n");
		      exit (0);
		      break;
		    }
		}
	      else
		{
		  for (j = 1; j < strlen (argv[i]); j++)
		    {
		      switch (argv[i][j])
			{
			case 'm':	// Create Key
			  i++;
			  if (  (i < argc) && (fout = fopen (argv[i], "w")))
			    {
			    	 j = strlen (argv[i]);
			
				  fwrite (&key[k], sizeof (char), 32, ran);
			      fout = fopen (argv[i], "w");
			      fwrite (key, sizeof (int), 32, fout);
			      fclose (fout);
			      printf ("Key was successfully created\n");
			      exit (EXIT_SUCCESS);
			    }
			  else
			    {
			      fprintf (stderr, "Could not create key file\n");
			      exit (EXIT_FAILURE);
			    }
			  break;
			case 'k':	// Read in key file
			  i++;
			  if ((i < argc) && (fin = fopen (argv[i], "r")))
			    {
			    	 j = strlen (argv[i]);
			
					  fread (key, sizeof (char), 32, fin);
			
			      fclose (fin);
			      printf ("Key correctly read .\n");
			      READY++;
			    }
			  else
			    {
			      fprintf (stderr,
				       "Error reading in key file \nusage: star -k <keyfile> [options]\n");
			      exit (EXIT_FAILURE);
			    }
			  break;
			case 'b':	// Block length
			  i++;
			  nb = (int) strtol (argv[i], NULL, 10) / 32;
			  if (nk != 4 && nk != 6 && nk != 8)
			    {
			      fprintf (stderr,
				       "Illegal block length option, must be 128, 192, or 256 bits\n");
			      fprintf (stderr,
				       "i.e. star -n 128 -cf <input.file>\n");
			      fprintf (stderr, "Key length is optional\n");
			    }
			  break;
			case 'f':	// in/out file
			  i++;
			  j = strlen (argv[i]);
			  strcpy (file, argv[i]);
			  READY++;
			  break;
			case 'x':
			  ENCRYPT = 0;
			  break;
			case 'c':
			  ENCRYPT = 1;
			  break;
			default:
			  printf
			    ("star: invalid option -- %c  Try \"star --help\" \n",
			     argv[i][j]);
			  exit (EXIT_FAILURE);
			}	// end of swich
		    }		// End of for
		}		// God I need auto indent...
	    }
	}			// end of for     
    }				// endif

  printf ("Block Size= %d bits, Key Size= %d bits\n", nb * 32, nk * 32);
  gkey (nb, nk, key);

  if (ENCRYPT == 1)
    {
      if ((fin = fopen (file, "r")))
	{
	  // Encrypt file.
	  if ((fout = fopen (strcat (file, ".star"), "w")))
	    {
	      while (fread (block, sizeof (char), 32, fin))
		{
		  encrypt (block);
		  fwrite (block, sizeof (char), 32, fout);
		  memset (block, 0, 32 * sizeof (char));
		}
	      fclose (fout);
	    }
	  else
	    {
	      fclose (fin);
	      fprintf (stderr, "Unable to create file for writing\n");
	      exit (EXIT_FAILURE);
	    }
	  fclose (fin);
	}
      else
	{
	  fprintf (stderr, "File not found for encrypting...\n");
	  exit (EXIT_FAILURE);
	}
    }
  else if (ENCRYPT == 0)
    {
      if ((fin = fopen (file, "r")))
	{
	  // Decrypt file.
	  if ((fout = fopen (strcat (file, ".out"), "w")))
	    {
	      while (fread (block, sizeof (char), 32, fin))
		{
		  decrypt (block);
		  fwrite (block, sizeof (char), 32, fout);
		  memset (block, 0, 32 * sizeof (char));
		}
	      fclose (fout);
	    }
	  else
	    {
	      fclose (fin);
	      fprintf (stderr, "Unable to create file for writing\n");
	      exit (EXIT_FAILURE);
	    }
	  fclose (fin);
	}
      else
	{
	  fprintf (stderr, "File not found for decrypting...\n");
	  exit (EXIT_FAILURE);
	}
    }
  else
    {
      fprintf (stderr,
	       "You forgot to put whether you want to encrypt or decrypt\n");
      fprintf (stderr, "Try star --help\n");
      exit (EXIT_FAILURE);
    }
  return EXIT_SUCCESS;
}
